.486
.model flat,stdcall
option casemap:none

include 	d:\masm32\include\windows.inc
include 	d:\masm32\include\user32.inc
include 	d:\masm32\include\kernel32.inc
include 	d:\masm32\include\gdi32.inc

includelib	d:\masm32\lib\user32.lib
includelib	d:\masm32\lib\kernel32.lib
includelib 	d:\masm32\lib\gdi32.lib

DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
DrawItem   PROTO :HWND,:LPARAM

.const
IDC_EXIT        equ 3002

; Colors
CR_BACKGROUND equ 00000000h ;   
CR_FOREGROUND equ 000000CAh ;  
;CR_HIGHLIGHT  equ 000000A4h	;  
CR_INPUT      equ 00000000h	;  
CR_TEXT       equ 000000CAh

.data
DlgName 		db "MD",0

.data?

hInstance 	HINSTANCE ?
hBgColor   HBRUSH    ?
hFgColor   HBRUSH    ?
hInColor   HBRUSH    ?
hEdge      HPEN      ?
sBtnText   TCHAR     16 dup(?)
.code
start:
    push 0
	call GetModuleHandle
	mov    hInstance,eax
	
	; Create brushes for custom colors
	INVOKE CreateSolidBrush, CR_BACKGROUND
	mov hBgColor, eax
	INVOKE CreateSolidBrush, CR_FOREGROUND
	mov hFgColor, eax
	INVOKE CreateSolidBrush, CR_INPUT
	mov hInColor, eax
	INVOKE CreatePen, PS_INSIDEFRAME, 1, CR_FOREGROUND
	mov hEdge, eax

    invoke DialogBoxParam, hInstance, ADDR DlgName,NULL,addr DlgProc,NULL
    
    
; Restore the memory used for graphic objects
	INVOKE DeleteObject, hEdge
	INVOKE DeleteObject, hInColor
	INVOKE DeleteObject, hFgColor
	INVOKE DeleteObject, hBgColor

	call ExitProcess

DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT

   dddd:
   	;------------------------------------------------
   	; 
   	.IF uMsg == WM_CTLCOLORDLG
    mov eax, hBgColor
    ret
    		
	.ELSEIF uMsg == WM_DRAWITEM
		invoke DrawItem, hWnd, lParam	
		   	
	.ELSEIF uMsg==WM_INITDIALOG  
		
	

	.ELSEIF uMsg==WM_COMMAND  
		mov eax,wParam
		.IF lParam==0
		.ELSE
			mov edx,wParam
			shr edx,16
			.if dx==BN_CLICKED
					                
				.IF ax==IDC_EXIT
				
				call ExitProcess
				.ENDIF
			.ENDIF
		.ENDIF
	
	.ELSE
		mov eax,FALSE
		ret
	.ENDIF
	mov eax,TRUE
	ret
DlgProc endp
;=====================================================================
DrawItem PROC hWnd: HWND, lParam: LPARAM
  push esi
  mov esi, lParam
  assume esi: ptr DRAWITEMSTRUCT

  INVOKE SelectObject, [esi].hdc, hInColor
  INVOKE SelectObject, [esi].hdc, hEdge

  INVOKE FillRect, [esi].hdc, ADDR [esi].rcItem, hBgColor
  INVOKE RoundRect, [esi].hdc, [esi].rcItem.left, [esi].rcItem.top, [esi].rcItem.right, [esi].rcItem.bottom, 6, 6

  .IF [esi].itemState & ODS_SELECTED
    INVOKE FillRect, [esi].hdc, ADDR [esi].rcItem, hBgColor ;
    INVOKE OffsetRect, ADDR [esi].rcItem, 1, 1 ;
    ;
    INVOKE RoundRect, [esi].hdc, [esi].rcItem.left, [esi].rcItem.top, [esi].rcItem.right, [esi].rcItem.bottom, 6, 6
   	
  .ENDIF

  ; Write the text
  INVOKE GetDlgItemText, hWnd, [esi].CtlID, ADDR sBtnText, SIZEOF sBtnText
  INVOKE SetBkMode, [esi].hdc, TRANSPARENT
  INVOKE SetTextColor, [esi].hdc, CR_TEXT
  INVOKE DrawText, [esi].hdc, ADDR sBtnText, -1, ADDR [esi].rcItem, DT_CENTER or DT_VCENTER or DT_SINGLELINE


  assume esi:nothing
  pop esi

  mov eax, TRUE
  ret
DrawItem ENDP
;====================================================================================

	
end start
